diff -crN nakedmudv1.5/src/editor/editor.d nakedmudv2.0/src/editor/editor.d
*** nakedmudv1.5/src/editor/editor.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/editor/editor.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ editor/editor.d editor/editor.o: editor/editor.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h auxiliary.h socket.h \
+   editor/editor.h
diff -crN nakedmudv1.5/src/editor/editor.h nakedmudv2.0/src/editor/editor.h
*** nakedmudv1.5/src/editor/editor.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/editor/editor.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,86 ----
+ #ifndef EDITOR_H
+ #define EDITOR_H
+ //*****************************************************************************
+ //
+ // editor.h
+ //
+ // one of the problems that came up with the origional text editor what that
+ // it started becoming rather kludgy and hackish as we started adding more
+ // features to it, like script editing capabilities. It was difficult to
+ // coordinate when we wanted certain options and when we didn't. This is an
+ // attempt to make things a bit easier to scale up with.
+ //
+ //*****************************************************************************
+ 
+ typedef struct editor_data EDITOR;
+ 
+ // a basic text editor that can be used by other modules
+ extern EDITOR *text_editor;
+ 
+ // an editor for dialog. Essentially, text without newlines
+ extern EDITOR *dialog_editor;
+ 
+ 
+ // prepare the editing system for use
+ void init_editor();
+ 
+ // sets up a little notepad that the character can write/post stuff from.
+ // Notepads are erased when the socket disconnects.
+ void init_notepad();
+ const char *socketGetNotepad(SOCKET_DATA *sock);
+ void socketSetNotepad(SOCKET_DATA *sock, const char *txt);
+ void socketStartNotepad(SOCKET_DATA *sock);
+ 
+ 
+ // editors are intended to be permenant and, thus, have no delete function.
+ // Modules that need an editing tool tailored to them (e.g. scripts) should make
+ // one copy of the editor when the module is initialized, and that should be the
+ // only copy ever used.
+ EDITOR *newEditor();
+ 
+ //
+ // Change the function that displays the editor prompt. By default, the editor
+ // prompt displays this:
+ // ] 
+ void editorSetPrompt(EDITOR *editor, void prompt(SOCKET_DATA *sock));
+ 
+ //
+ // When an editor is first entered, the socket may need some auxiliary data
+ // reset (e.g.: script editing will need indents set to zero). This is where
+ // all of that stuff is performed. The default editor does not have an init()
+ // and can be written over at will.
+ void editorSetInit(EDITOR *editor, void init(SOCKET_DATA *sock));
+ 
+ //
+ // change the function that appends data to the buffer. This may be useful in
+ // some cases where previous input determines how the next input is appended.
+ // So, for instance, if/else blocks for scripts.
+ void editorSetAppend(EDITOR *editor,
+ 		     void append(SOCKET_DATA *sock, char *arg, BUFFER *buf));
+ 
+ //
+ // add a new command to the text editor, and map it to an editor function. The
+ // desc is the line that will be displayed in the help menu. The following 
+ // commands are reserved, and cannot be added over or removed:
+ //   /s, /q      quit and save changes
+ //   /a          quit but do not save changes
+ //   /h, /?      display the help menu
+ void editorAddCommand(EDITOR *editor, const char *cmd, const char *desc, 
+ 		      void func(SOCKET_DATA *sock, char *arg, BUFFER *buf));
+ 
+ //
+ // Remove a command from the text editor. None of the reserved commands can be
+ // removed. This is basically intended to allow programmers to remove
+ // functionality from the default editor to customize it.
+ void editorRemoveCommand(EDITOR *editor, const char *cmd);
+ 
+ //
+ // Make the socket start editing the specified buffer with the supplied
+ // text editor.
+ void socketStartEditor(SOCKET_DATA *sock, EDITOR *editor, BUFFER *buf);
+ 
+ //
+ // get a pointer to the current editor the socket is using, if any
+ EDITOR *socketGetEditor(SOCKET_DATA *sock);
+ 
+ #endif // EDITOR_H
diff -crN nakedmudv1.5/src/editor/module.mk nakedmudv2.0/src/editor/module.mk
*** nakedmudv1.5/src/editor/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/editor/module.mk	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ SRC += editor/editor.c editor/notepad.c
diff -crN nakedmudv1.5/src/editor/notepad.c nakedmudv2.0/src/editor/notepad.c
*** nakedmudv1.5/src/editor/notepad.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/editor/notepad.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,100 ----
+ //*****************************************************************************
+ //
+ // notepad.c
+ //
+ // Here is the proof of concept for the editor utility. This is a basic text
+ // editor that allows players to write/read information contained within a
+ // notepad.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../inform.h"
+ #include "../auxiliary.h"
+ #include "../socket.h"
+ #include "../character.h"
+ #include "editor.h"
+ 
+ 
+ 
+ //*****************************************************************************
+ // auxiliary data for sockets
+ //*****************************************************************************
+ typedef struct notepad_data {
+   BUFFER *notepad;
+ } NOTEPAD_DATA;
+ 
+ NOTEPAD_DATA *newNotepadData() {
+   NOTEPAD_DATA *data = malloc(sizeof(NOTEPAD_DATA));
+   data->notepad = newBuffer(1);
+   return data;
+ }
+ 
+ void deleteNotepadData(NOTEPAD_DATA *data) {
+   if(data->notepad) deleteBuffer(data->notepad);
+   free(data);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // local datastructures, functions, and commands for players
+ //*****************************************************************************
+ void socketStartNotepad(SOCKET_DATA *sock) {
+   NOTEPAD_DATA *data = socketGetAuxiliaryData(sock, "notepad_data");
+   socketStartEditor(sock, text_editor, data->notepad);
+ }
+ 
+ COMMAND(cmd_write) {
+   if(!charGetSocket(ch))
+     text_to_char(ch, "You need an attached socket for that!\r\n");
+   else {
+     message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR, 
+ 	    "$n pulls out a pen and begins jotting notes down.");
+     socketStartNotepad(charGetSocket(ch));
+   }
+ }
+ 
+ COMMAND(cmd_notepad) {
+   if(!charGetSocket(ch))
+     text_to_char(ch, "You need an attached socket for that!\r\n");
+   else {
+     SOCKET_DATA *sock = charGetSocket(ch);
+     NOTEPAD_DATA *data = socketGetAuxiliaryData(sock, "notepad_data");
+     if(!*bufferString(data->notepad))
+       text_to_char(ch, "Your notepad is empty.\r\n");
+     else
+       text_to_char(ch, bufferString(data->notepad));
+   }
+ }
+ 
+ const char *socketGetNotepad(SOCKET_DATA *sock) {
+   NOTEPAD_DATA *data = socketGetAuxiliaryData(sock, "notepad_data");
+   return bufferString(data->notepad);
+ }
+ 
+ void socketSetNotepad(SOCKET_DATA *sock, const char *txt) {
+   NOTEPAD_DATA *data = socketGetAuxiliaryData(sock, "notepad_data");
+   bufferClear(data->notepad);
+   bufferCat(data->notepad, txt);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ // setting everything up...
+ //*****************************************************************************
+ void init_notepad() {
+   // install the editor components
+   auxiliariesInstall("notepad_data", 
+ 		     newAuxiliaryFuncs(AUXILIARY_TYPE_SOCKET,
+ 				       newNotepadData, deleteNotepadData,
+ 				       NULL, NULL, NULL, NULL));
+ 
+   // install our commands
+   add_cmd("write", NULL, cmd_write, 0, POS_SITTING, POS_FLYING,
+ 	  LEVEL_PLAYER, FALSE, TRUE);
+   add_cmd("notepad", NULL, cmd_notepad, 0, POS_SITTING, POS_FLYING,
+ 	  LEVEL_PLAYER, FALSE, TRUE);
+ }
diff -crN nakedmudv1.5/src/editor/notepad.d nakedmudv2.0/src/editor/notepad.d
*** nakedmudv1.5/src/editor/notepad.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/editor/notepad.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ editor/notepad.d editor/notepad.o: editor/notepad.c mud.h wrapsock.h property_table.h list.h \
+   map.h hashtable.h set.h buffer.h bitvector.h utils.h inform.h \
+   auxiliary.h socket.h character.h editor/editor.h
diff -crN nakedmudv1.5/src/event.c nakedmudv2.0/src/event.c
*** nakedmudv1.5/src/event.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/event.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 114,119 ****
--- 114,124 ----
    // add our proof of concept command
    add_cmd("devent", NULL, cmd_devent, 0, POS_SLEEPING, POS_FLYING,
  	  LEVEL_ADMIN, TRUE, FALSE);
+ 
+   // make sure all events involving the object/char are cancelled when
+   // either is extracted from the game
+   add_extract_obj_func((void (*)(OBJ_DATA *)) interrupt_events_involving);
+   add_extract_mob_func((void (*)(CHAR_DATA *))interrupt_events_involving);
  }
  
  void interrupt_event(EVENT_DATA *event) {
diff -crN nakedmudv1.5/src/event.d nakedmudv2.0/src/event.d
*** nakedmudv1.5/src/event.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/event.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ event.d event.o: event.c mud.h wrapsock.h property_table.h list.h map.h \
+   hashtable.h set.h buffer.h bitvector.h utils.h character.h event.h
diff -crN nakedmudv1.5/src/exit.c nakedmudv2.0/src/exit.c
*** nakedmudv1.5/src/exit.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/exit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 19,25 ****
  struct exit_data {
    char *name;              // what is the name of our door for descriptions?
    char *keywords;          // what keywords can the door be referenced by?
!   char *description;       // what does a person see when they look at us?
  
    char *spec_enter;        // the message when we enter from this exit
    char *spec_leave;        // the message when we leave through this exit
--- 19,25 ----
  struct exit_data {
    char *name;              // what is the name of our door for descriptions?
    char *keywords;          // what keywords can the door be referenced by?
!   BUFFER *desc;            // what does a person see when they look at us?
  
    char *spec_enter;        // the message when we enter from this exit
    char *spec_leave;        // the message when we leave through this exit
***************
*** 40,82 ****
    EXIT_DATA *exit = malloc(sizeof(EXIT_DATA));
    exit->name        = strdup("");
    exit->keywords    = strdup("");
-   exit->description = strdup("");
    exit->spec_enter  = strdup("");
    exit->spec_leave  = strdup("");
!   exit->key    = NOTHING;
!   exit->to     = NOWHERE;
!   exit->hide_lev = 0;
!   exit->pick_lev = 0;
!   exit->status   = 0;
!   exit->closable = FALSE;
    return exit;
  };
  
  
  void deleteExit(EXIT_DATA *exit) {
    if(exit->name)        free(exit->name);
-   if(exit->description) free(exit->description);
    if(exit->spec_enter)  free(exit->spec_enter);
    if(exit->spec_leave)  free(exit->spec_leave);
    if(exit->keywords)    free(exit->keywords);
  
    free(exit);
  };
  
  
  void exitCopyTo(const EXIT_DATA *from, EXIT_DATA *to) {
!   exitSetName       (to, exitGetName(from));
!   exitSetKeywords   (to, exitGetKeywords(from));
!   exitSetDescription(to, exitGetDesc(from));
!   exitSetTo         (to, exitGetTo(from));
!   exitSetPickLev    (to, exitGetPickLev(from));
!   exitSetHidden     (to, exitGetHidden(from));
!   exitSetKey        (to, exitGetKey(from));
!   exitSetLocked     (to, exitIsLocked(from));
!   exitSetClosed     (to, exitIsClosed(from));
!   exitSetClosable   (to, exitIsClosable(from));
!   exitSetSpecEnter  (to, exitGetSpecEnter(from));
!   exitSetSpecLeave  (to, exitGetSpecLeave(from));
  }
  
  
--- 40,82 ----
    EXIT_DATA *exit = malloc(sizeof(EXIT_DATA));
    exit->name        = strdup("");
    exit->keywords    = strdup("");
    exit->spec_enter  = strdup("");
    exit->spec_leave  = strdup("");
!   exit->desc        = newBuffer(1);
!   exit->key         = NOTHING;
!   exit->to          = NOWHERE;
!   exit->hide_lev    = 0;
!   exit->pick_lev    = 0;
!   exit->status      = 0;
!   exit->closable    = FALSE;
    return exit;
  };
  
  
  void deleteExit(EXIT_DATA *exit) {
    if(exit->name)        free(exit->name);
    if(exit->spec_enter)  free(exit->spec_enter);
    if(exit->spec_leave)  free(exit->spec_leave);
    if(exit->keywords)    free(exit->keywords);
+   if(exit->desc)        deleteBuffer(exit->desc);
  
    free(exit);
  };
  
  
  void exitCopyTo(const EXIT_DATA *from, EXIT_DATA *to) {
!   exitSetName     (to, exitGetName(from));
!   exitSetKeywords (to, exitGetKeywords(from));
!   exitSetDesc     (to, exitGetDesc(from));
!   exitSetTo       (to, exitGetTo(from));
!   exitSetPickLev  (to, exitGetPickLev(from));
!   exitSetHidden   (to, exitGetHidden(from));
!   exitSetKey      (to, exitGetKey(from));
!   exitSetLocked   (to, exitIsLocked(from));
!   exitSetClosed   (to, exitIsClosed(from));
!   exitSetClosable (to, exitIsClosable(from));
!   exitSetSpecEnter(to, exitGetSpecEnter(from));
!   exitSetSpecLeave(to, exitGetSpecLeave(from));
  }
  
  
***************
*** 88,103 ****
  
  EXIT_DATA *exitRead(STORAGE_SET *set) {
    EXIT_DATA *exit = newExit();
!   exitSetName(exit,        read_string(set, "name"));
!   exitSetKeywords(exit,    read_string(set, "keywords"));
!   exitSetDescription(exit, read_string(set, "desc"));
!   exitSetSpecEnter(exit,   read_string(set, "enter"));
!   exitSetSpecLeave(exit,   read_string(set, "leave"));
!   exitSetTo(exit,          read_int   (set, "to"));
!   exitSetKey(exit,         read_int   (set, "key"));
!   exitSetHidden(exit,      read_int   (set, "hide_level"));
!   exitSetPickLev(exit,     read_int   (set, "pick_level"));
!   exitSetClosable(exit,    read_int   (set, "closable"));
    return exit;
  }
  
--- 88,103 ----
  
  EXIT_DATA *exitRead(STORAGE_SET *set) {
    EXIT_DATA *exit = newExit();
!   exitSetName(exit,      read_string(set, "name"));
!   exitSetKeywords(exit,  read_string(set, "keywords"));
!   exitSetDesc(exit,      read_string(set, "desc"));
!   exitSetSpecEnter(exit, read_string(set, "enter"));
!   exitSetSpecLeave(exit, read_string(set, "leave"));
!   exitSetTo(exit,        read_int   (set, "to"));
!   exitSetKey(exit,       read_int   (set, "key"));
!   exitSetHidden(exit,    read_int   (set, "hide_level"));
!   exitSetPickLev(exit,   read_int   (set, "pick_level"));
!   exitSetClosable(exit,  read_int   (set, "closable"));
    return exit;
  }
  
***************
*** 105,111 ****
    STORAGE_SET *set = new_storage_set();
    store_string(set, "name",       exit->name);
    store_string(set, "keywords",   exit->keywords);
!   store_string(set, "desc",       exit->description);
    store_string(set, "enter",      exit->spec_enter);
    store_string(set, "leave",      exit->spec_leave);
    store_int   (set, "to",         exit->to);
--- 105,111 ----
    STORAGE_SET *set = new_storage_set();
    store_string(set, "name",       exit->name);
    store_string(set, "keywords",   exit->keywords);
!   store_string(set, "desc",       bufferString(exit->desc));
    store_string(set, "enter",      exit->spec_enter);
    store_string(set, "leave",      exit->spec_leave);
    store_int   (set, "to",         exit->to);
***************
*** 166,172 ****
  };
  
  const char *exitGetDesc(const EXIT_DATA *exit) {
!   return exit->description;
  };
  
  const char *exitGetSpecEnter(const EXIT_DATA *exit) {
--- 166,172 ----
  };
  
  const char *exitGetDesc(const EXIT_DATA *exit) {
!   return bufferString(exit->desc);
  };
  
  const char *exitGetSpecEnter(const EXIT_DATA *exit) {
***************
*** 177,185 ****
    return exit->spec_leave;
  };
  
! char      **exitGetDescPtr(EXIT_DATA *exit) {
!   return &(exit->description);
! };
  
  void        exitSetClosable(EXIT_DATA *exit, bool closable) {
    exit->closable = (closable != 0);
--- 177,185 ----
    return exit->spec_leave;
  };
  
! BUFFER *exitGetDescBuffer(const EXIT_DATA *exit) {
!   return exit->desc;
! }
  
  void        exitSetClosable(EXIT_DATA *exit, bool closable) {
    exit->closable = (closable != 0);
***************
*** 223,232 ****
    else               exit->keywords = strdup("");
  };
  
! void        exitSetDescription(EXIT_DATA *exit, const char *desc) {
!   if(exit->description) free(exit->description);
!   if(desc)              exit->description = strdup(desc);
!   else                  exit->description = strdup("");
  };
  
  void        exitSetSpecEnter(EXIT_DATA *exit, const char *enter) {
--- 223,231 ----
    else               exit->keywords = strdup("");
  };
  
! void        exitSetDesc(EXIT_DATA *exit, const char *desc) {
!   bufferClear(exit->desc);
!   bufferCat(exit->desc, (desc ? desc : ""));
  };
  
  void        exitSetSpecEnter(EXIT_DATA *exit, const char *enter) {
diff -crN nakedmudv1.5/src/exit.d nakedmudv2.0/src/exit.d
*** nakedmudv1.5/src/exit.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/exit.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ exit.d exit.o: exit.c mud.h wrapsock.h property_table.h list.h map.h hashtable.h \
+   set.h buffer.h bitvector.h utils.h storage.h exit.h
diff -crN nakedmudv1.5/src/exit.h nakedmudv2.0/src/exit.h
*** nakedmudv1.5/src/exit.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/exit.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 65,72 ****
  const char *exitGetDesc        (const EXIT_DATA *exit);
  const char *exitGetSpecLeave   (const EXIT_DATA *exit);
  const char *exitGetSpecEnter   (const EXIT_DATA *exit);
! // for editing exit descriptions in the text editor
! char      **exitGetDescPtr     (EXIT_DATA *exit);
  
  void        exitSetClosable    (EXIT_DATA *exit, bool closable);
  void        exitSetClosed      (EXIT_DATA *exit, bool closed);
--- 65,71 ----
  const char *exitGetDesc        (const EXIT_DATA *exit);
  const char *exitGetSpecLeave   (const EXIT_DATA *exit);
  const char *exitGetSpecEnter   (const EXIT_DATA *exit);
! BUFFER     *exitGetDescBuffer  (const EXIT_DATA *exit);
  
  void        exitSetClosable    (EXIT_DATA *exit, bool closable);
  void        exitSetClosed      (EXIT_DATA *exit, bool closed);
***************
*** 77,83 ****
  void        exitSetTo          (EXIT_DATA *exit, room_vnum room);
  void        exitSetName        (EXIT_DATA *exit, const char *name);
  void        exitSetKeywords    (EXIT_DATA *exit, const char *keywords);
! void        exitSetDescription (EXIT_DATA *exit, const char *desc);
  void        exitSetSpecLeave   (EXIT_DATA *exit, const char *leave);
  void        exitSetSpecEnter   (EXIT_DATA *exit, const char *enter);
  
--- 76,82 ----
  void        exitSetTo          (EXIT_DATA *exit, room_vnum room);
  void        exitSetName        (EXIT_DATA *exit, const char *name);
  void        exitSetKeywords    (EXIT_DATA *exit, const char *keywords);
! void        exitSetDesc        (EXIT_DATA *exit, const char *desc);
  void        exitSetSpecLeave   (EXIT_DATA *exit, const char *leave);
  void        exitSetSpecEnter   (EXIT_DATA *exit, const char *enter);
  
diff -crN nakedmudv1.5/src/extra_descs.c nakedmudv2.0/src/extra_descs.c
*** nakedmudv1.5/src/extra_descs.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv2.0/src/extra_descs.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 20,27 ****
  
  struct edesc_data {
    EDESC_SET *set;
!   char *keywords;
!   char *desc;
  };
  
  
--- 20,27 ----
  
  struct edesc_data {
    EDESC_SET *set;
!   char      *keywords;
!   BUFFER    *desc;
  };
  
  
***************
*** 44,50 ****
  STORAGE_SET *edescStore(EDESC_DATA *data) {
    STORAGE_SET *set = new_storage_set();
    store_string(set, "keywords", data->keywords);
!   store_string(set, "desc",     data->desc);
    return set;
  }
  
--- 44,50 ----
  STORAGE_SET *edescStore(EDESC_DATA *data) {
    STORAGE_SET *set = new_storage_set();
    store_string(set, "keywords", data->keywords);
!   store_string(set, "desc",     bufferString(data->desc));
    return set;
  }
  
***************
*** 69,75 ****
  }
  
  
! void copyEdescSetTo(EDESC_SET *from, EDESC_SET *to) {
    // delete all of the current entries
    deleteListWith(to->edescs, deleteEdesc);
    to->edescs = newList();
--- 69,75 ----
  }
  
  
! void edescSetCopyTo(EDESC_SET *from, EDESC_SET *to) {
    // delete all of the current entries
    deleteListWith(to->edescs, deleteEdesc);
    to->edescs = newList();
***************
*** 78,100 ****
    EDESC_DATA    *entry   = NULL;
    LIST_ITERATOR *edesc_i = newListIterator(from->edescs);
    ITERATE_LIST(entry, edesc_i)
!     edescSetPut(to, copyEdesc(entry));
    deleteListIterator(edesc_i);
  }
  
  
! EDESC_SET *copyEdescSet(EDESC_SET *set) {
    EDESC_SET *newset = newEdescSet();
!   copyEdescSetTo(set, newset);
    return newset;
  }
  
! EDESC_DATA *getEdesc            (EDESC_SET *set, const char *keyword) {
    LIST_ITERATOR *edesc_i = newListIterator(set->edescs);
    EDESC_DATA       *desc = NULL;
  
    ITERATE_LIST(desc, edesc_i)
!     if(isEdescKeyword(desc, keyword))
        break;
    
    deleteListIterator(edesc_i);
--- 78,100 ----
    EDESC_DATA    *entry   = NULL;
    LIST_ITERATOR *edesc_i = newListIterator(from->edescs);
    ITERATE_LIST(entry, edesc_i)
!     edescSetPut(to, edescCopy(entry));
    deleteListIterator(edesc_i);
  }
  
  
! EDESC_SET *edescSetCopy(EDESC_SET *set) {
    EDESC_SET *newset = newEdescSet();
!   edescSetCopyTo(set, newset);
    return newset;
  }
  
! EDESC_DATA *edescSetGet            (EDESC_SET *set, const char *keyword) {
    LIST_ITERATOR *edesc_i = newListIterator(set->edescs);
    EDESC_DATA       *desc = NULL;
  
    ITERATE_LIST(desc, edesc_i)
!     if(edescIsKeyword(desc, keyword))
        break;
    
    deleteListIterator(edesc_i);
***************
*** 106,112 ****
    listQueue(set->edescs, edesc);
  }
  
! EDESC_DATA *getEdescNum         (EDESC_SET *set, int num) {
    return listGet(set->edescs, num);
  }
  
--- 106,112 ----
    listQueue(set->edescs, edesc);
  }
  
! EDESC_DATA *edescSetGetNum         (EDESC_SET *set, int num) {
    return listGet(set->edescs, num);
  }
  
***************
*** 115,128 ****
      edesc->set = NULL;
  }
  
! EDESC_DATA *removeEdescEntry    (EDESC_SET *set, const char *keyword) {
!   EDESC_DATA *entry = getEdesc(set, keyword);
    if(entry && listRemove(set->edescs, entry))
      entry->set = NULL;
    return entry;
  }
  
! EDESC_DATA *removeEdescEntryNum (EDESC_SET *set, int num) {
    EDESC_DATA *entry = listRemoveNum(set->edescs, num);
    if(entry)
      entry->set = NULL;
--- 115,128 ----
      edesc->set = NULL;
  }
  
! EDESC_DATA *edescSetRemove    (EDESC_SET *set, const char *keyword) {
!   EDESC_DATA *entry = edescSetGet(set, keyword);
    if(entry && listRemove(set->edescs, entry))
      entry->set = NULL;
    return entry;
  }
  
! EDESC_DATA *edescSetRemoveNum (EDESC_SET *set, int num) {
    EDESC_DATA *entry = listRemoveNum(set->edescs, num);
    if(entry)
      entry->set = NULL;
***************
*** 139,149 ****
    free(set);
  }
  
! int         getEdescSetSize     (EDESC_SET *set) {
    return listSize(set->edescs);
  }
  
! LIST       *getEdescList        (EDESC_SET *set) {
    return set->edescs;
  }
  
--- 139,149 ----
    free(set);
  }
  
! int         edescGetSetSize     (EDESC_SET *set) {
    return listSize(set->edescs);
  }
  
! LIST       *edescSetGetList        (EDESC_SET *set) {
    return set->edescs;
  }
  
***************
*** 176,231 ****
    EDESC_DATA *edesc = malloc(sizeof(struct edesc_data));
  
    edesc->set      = NULL;
-   edesc->desc     = (desc ? strdup(desc) : strdup(""));
    edesc->keywords = strdup((keywords ? keywords : ""));
  
    return edesc;
  }
  
  void deleteEdesc(EDESC_DATA *edesc) {
    if(edesc->keywords) free(edesc->keywords);
!   if(edesc->desc)     free(edesc->desc);
    free(edesc);
  }
  
! EDESC_DATA *copyEdesc(EDESC_DATA *edesc) {
!   return newEdesc(edesc->keywords, edesc->desc);
  }
  
! void copyEdescTo(EDESC_DATA *from, EDESC_DATA *to) {
    // copy over the new desc
!   if(to->desc) free(to->desc);
!   to->desc = strdup(from->desc ? from->desc : "");
    if(to->keywords) free(to->keywords);
    to->keywords = strdup(from->keywords ? from->keywords : "");
  }
  
! const char *getEdescKeywords(EDESC_DATA *edesc) {
    return edesc->keywords;
  }
  
! const char *getEdescDescription(EDESC_DATA *edesc) {
!   return edesc->desc;
  }
  
! char **getEdescPtr(EDESC_DATA *edesc) {
!   return &(edesc->desc);
  }
  
! void setEdescKeywords(EDESC_DATA *edesc, const char *keywords) {
    if(edesc->keywords) free(edesc->keywords);
    edesc->keywords   = strdup((keywords ? keywords :""));
  }
  
! void setEdescDescription(EDESC_DATA *edesc, const char *description) {
!   if(edesc->desc) free(edesc->desc);
!   edesc->desc = (description ? strdup(description) : strdup(""));
  }
  
! EDESC_SET *getEdescSet(EDESC_DATA *edesc) {
    return edesc->set;
  }
  
! bool isEdescKeyword(EDESC_DATA *edesc, const char *keyword) {
    return is_keyword(edesc->keywords, keyword, TRUE);
  }
--- 176,231 ----
    EDESC_DATA *edesc = malloc(sizeof(struct edesc_data));
  
    edesc->set      = NULL;
    edesc->keywords = strdup((keywords ? keywords : ""));
+   edesc->desc     = newBuffer(1);
+   bufferCat(edesc->desc, (desc ? desc : ""));
  
    return edesc;
  }
  
  void deleteEdesc(EDESC_DATA *edesc) {
    if(edesc->keywords) free(edesc->keywords);
!   if(edesc->desc)     deleteBuffer(edesc->desc);
    free(edesc);
  }
  
! EDESC_DATA *edescCopy(EDESC_DATA *edesc) {
!   return newEdesc(edesc->keywords, bufferString(edesc->desc));
  }
  
! void edescCopyTo(EDESC_DATA *from, EDESC_DATA *to) {
    // copy over the new desc
!   bufferCopyTo(from->desc, to->desc);
    if(to->keywords) free(to->keywords);
    to->keywords = strdup(from->keywords ? from->keywords : "");
  }
  
! const char *edescSetGetKeywords(EDESC_DATA *edesc) {
    return edesc->keywords;
  }
  
! const char *edescSetGetDesc(EDESC_DATA *edesc) {
!   return bufferString(edesc->desc);
  }
  
! BUFFER *edescGetDescBuffer(EDESC_DATA *edesc) {
!   return edesc->desc;
  }
  
! void edescSetKeywords(EDESC_DATA *edesc, const char *keywords) {
    if(edesc->keywords) free(edesc->keywords);
    edesc->keywords   = strdup((keywords ? keywords :""));
  }
  
! void edescSetDesc(EDESC_DATA *edesc, const char *description) {
!   bufferClear(edesc->desc);
!   bufferCat(edesc->desc, (description ? description : ""));
  }
  
! EDESC_SET *edescGetSet(EDESC_DATA *edesc) {
    return edesc->set;
  }
  
! bool edescIsKeyword(EDESC_DATA *edesc, const char *keyword) {
    return is_keyword(edesc->keywords, keyword, TRUE);
  }
diff -crN nakedmudv1.5/src/extra_descs.d nakedmudv2.0/src/extra_descs.d
*** nakedmudv1.5/src/extra_descs.d	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv2.0/src/extra_descs.d	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,3 ----
+ extra_descs.d extra_descs.o: extra_descs.c mud.h wrapsock.h property_table.h list.h \
+   map.h hashtable.h set.h buffer.h bitvector.h utils.h storage.h \
+   extra_descs.h
